/*
    Public domain
*/

#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[]) {
    size_t i;
    if (argc != 2) {
        fprintf(stderr, "Wrong number of arguments\n");
        return -1;
    }

    FILE* file = fopen(argv[1], "rb");
    if (!file) {
        fprintf(stderr, "Unable to open file\n");
        return -1;
    }

    fprintf(stdout,
    "// Autogenerated header file\n"
    "unsigned char loaderbin[] = {"
    );

    for (i=0; !feof(file); i++) {
        unsigned char c = fgetc(file);
        fprintf(stdout, "%s0x%02x,", (i%8)?"":"\n    ", c);
    }
    fclose(file);

    fprintf(stdout,
    "\n};\n"
    );

    return 0;
}